﻿
/*
* Běžná funkce
*/
function standardFunction(a, b) {
    return a + b;
}
standardFunction(1, 2);
standardFunction(1, "dvacet");



/*
* Funkce s typy funkce
*/
function typedFunction(a: number, b: number): number {
    return a + b;
}
typedFunction(1, 2);
// Pro ukázku odkomentovat
//typedFunction(1, "dvacet");





/*
* Šipková funkce (Arrow function) - v podstatě lambda funkce
*/
var arrowFunction1 = (x: number) => x * x;

var arrowFunction2 = (x: number) => {
    return x * x;
};





/*
* Rozdíl mezi Arrow funkcí a funkcí
*/
function Cat() {
    this.numberOfLegs = 4;
}

Cat.prototype.testFunction = function () {
    var fn = function () {
        return this.numberOfLegs;
    };
    return fn();
};

Cat.prototype.testArrowFunction = function () {
    var fn = () => {
        return this.numberOfLegs;
    };
    return fn();
};

var cat = new Cat();
cat.testFunction(); // Vrátí undefined
cat.testArrowFunction(); // Vrátí 4






/*
* Funkce jako datový typ
*/
var callback: (a: number, b: number) => string;

// Bez typů
callback = (a, b) => {
    return (a + b).toString();
};

// S typy
callback = (a: number, b: number): string => {
    return (a + b).toString();
};

// Pro ukázku odkomentovat
/*
callback = (a, b) => {
    return a + b;
};
*/






/*
* Defaultní parametry
*/
function customPow(base: number, exponent: number = 2): number {
    return Math.pow(base, exponent)
}

customPow(10);

customPow(12, 5);




/*
* Volitelné parametry
*/
function customPow2(base: number, exponent?: number): number {
    if (typeof exponent === "undefined") { exponent = 2; }
    return Math.pow(base, exponent);
}

customPow2(10);

customPow2(12, 5);