﻿
/*
* Nejjednodušší třída
*/
class BaseClass {
}
var baseClassInstance: BaseClass = new BaseClass();




/*
* Třída 1
*/
class Animal {

    private name: string = null;
    public isMammal: boolean;

    // Konstruktor
    constructor(isMammal: boolean) {
        this.isMammal = isMammal;
    }

    public setName(name: string) {
        this.name = name;
    }

    // Modifikátor public/private není poviný
    getName() {
        return this.name;
    }
}

var animalInstance: Animal = new Animal(true);




/*
* Třída 2 (neinicializované proměnné)
*/
class User {

    public firstName: string;
    public lastName: string = null;
    public age: number;

    constructor(age: number) {
        this.age = age;
    }

    public getFirstName() {
        return this.firstName;
    }

    public getLastName() {
        return this.lastName;
    }

}

var userInstance = new User(20);
userInstance.getFirstName(); // Vrátí undefined
userInstance.getLastName(); // Vrátí null



/*
* Dědičnost
*/
class BillGates extends User {

    constructor() {
        super(57);
        this.firstName = "Bill";
        this.lastName = "Gates";
    }

    public hasWife() {
        return true;
    }
}

var billGatesInstance = new BillGates();
billGatesInstance.getFirstName(); // Bill
billGatesInstance.getLastName(); // Gates
billGatesInstance.hasWife(); // true








/*
* Statické metody a atributy
* Pro vytvoření singletonu použijeme "hack", protože neexistuje privátní konstruktor
*/
class SingletonClass {

    private static instance: SingletonClass = null;

    private static canCreateInstance: boolean = false;

    public static GetInstance(): SingletonClass {

        if (SingletonClass.instance === null) {

            SingletonClass.canCreateInstance = true;
            SingletonClass.instance = new SingletonClass();
            SingletonClass.canCreateInstance = false;

        }

        return SingletonClass.instance;
    }

    constructor() {
        if (!SingletonClass.canCreateInstance) {
            throw new Error("'SingletonClass' is singleton! Please use 'GetInstance' method.");
        }

    }

}

var singletonClassInstance1 = SingletonClass.GetInstance();
var singletonClassInstance2 = SingletonClass.GetInstance();
var equals = singletonClassInstance1 === singletonClassInstance2 ? true : false; // true
var singletonClassInstance3 = new SingletonClass(); // Chyba