﻿
/*
* Základní interface
*/
interface IPoint {
    x: number;
    y: number;
}


// Proměnná typu 'bod'
var myPoint: IPoint;


/*
* Primitivní objekt
*/
myPoint = {
    x: 10,
    y: 20
};

// Pro ukázku odkomentovat
/*
myPoint = {
    x: 2
};
*/



/* 
* Poznámka:
* Nikde jsme nedeklarovali, že objekt implementuje IPoint, ale bez problému 
* jsme jej přiřadili do proměnné typu IPoint (v C#, Java, atd.. by neprošlo). 
* Vysvětlit!
*/




/*
* Třída implementující interface
*/
class Point2D implements IPoint {
    public x: number;
    public y: number;

    constructor(x: number, y: number) {
        this.x = x;
        this.y = y;
    }
}
myPoint = new Point2D(5.2, 86);




/*
* Dědičnost interface
*/
interface IPoint3D extends IPoint {
    z: number;
}

var point3d: IPoint3D = {
    x: 5,
    y: 20,
    z: 0.12
};

var point2d: IPoint = point3d;

// Pro ukázku odkomentovat
//point3d = point2d;







/*
* Volitelné metody a atributy v interface
*/

interface IUserData{
    name: string;
    age?: number;
    getName: () => string;
    getAge?: () => number;
}

// Korektní implementace 1
class UserData1 implements IUserData{
    public name: string;
    public age: number;
    public getName() {
        return this.name;
    }
    public getAge() {
        return this.age;
    }
}

// Korektní implementace 2
class UserData2 implements IUserData {
    public name: string;
    public getName() {
        return this.name;
    }
}








